% WARNING WORKSPACE WILL BE CLEARED!

%THIS DEMO BUILDS A CUBOID OF POINTS AND PICK THE ONES INSIDE THE MANIFOLD

clc
clearvars
close all
dbstop error

%UNCOMMENT ONE FO THE FOLLOWING LINES AND RUN

load TubularCuboidSurface.mat;
% load SphereSurface.mat;
% load CylinderSurface.mat;
% load StubAxleSurface.mat;
% load Cube_Surface.mat
% load Block_Surface.mat

%Gets a cuboid of points
N=30;%points in x direction

step=(-min(p(:,1))+max(p(:,1)))/N;

nx=ceil((-min(p(:,1))+max(p(:,1)))/step);
ny=ceil((-min(p(:,2))+max(p(:,2)))/step);
nz=ceil((-min(p(:,3))+max(p(:,3)))/step);

xp=linspace(min(p(:,1)),max(p(:,1)),nx);
yp=linspace(min(p(:,2)),max(p(:,2)),ny);
zp=linspace(min(p(:,3)),max(p(:,3)),nz);

[xp,yp,zp] = meshgrid(xp,yp,zp);
qp=[xp(:),yp(:),zp(:)];

clear xp yp zp;

% profile on;profile clear;
tic
in=InPolyedron(p,t,tnorm,qp);
fprintf('Searching %4.0f query points in %4.0f triangles took: %4.4f s\n',nx*ny*nz,size(t,1),toc);
% profile report;profile off;

close all
figure(1)

subplot(1,2,1);
hold on
axis equal
title('Starting Points and Surface','Fontsize',14)
set(gcf,'position',[100 100 1000 600])
trisurf(t,p(:,1),p(:,2),p(:,3),'facecolor','c','edgecolor','b')
view(3)
axis vis3d


subplot(1,2,2);
hold on
axis equal
title('Selected Points','Fontsize',14)
plot3(qp(in,1),qp(in,2),qp(in,3),'r.');
view(3)
axis vis3d